/**
 * @author floyd
 */

//扩展数组方法，添加删除方法
Array.prototype.remove = function(obj){
	
	for(var i=0,l=this.length;i<l;i++){
		
		if(this[i] == obj){
			this.splice(i,1);
			break;
		}
	}
}

//游戏控制类
var Game = {
	//小球列表
	arrSmallBalls : [],
	//大球列表
	arrBalls : [],
	//循环ID
	timeId : -1,
	//context2d对象
	gamebg : null,
	//游戏背景信息
	gameinfo : {},
	//总共的小球
	totalSBall : 20,
	//可以点击次数
	canClick : 2,
	//开始按钮
	btn : null,
	//初始化
	init : function(){
		//获取游戏背景dom
		var game_dom = document.getElementById('gamebg'),This = this;
		//设置游戏背景信息
		this.gameinfo = {
			width:game_dom.clientWidth,
			height:game_dom.clientHeight,
			left : game_dom.offsetLeft,
			top : game_dom.offsetTop
		};
		//获取context2d对象
		this.gamebg = game_dom.getContext('2d');
		//绑定鼠标按下事件
		game_dom.onmousedown = function(e){This.mouseDown(e);};
		//创建小球
		this.createSmallBall();
	},
	//鼠标按下事件
	mouseDown : function(e){
		//可以点击次数为0，不给点
		if(this.canClick <= 0)return;
		
		e = e || window.event;
		//获取鼠标当前相对于游戏背景的坐标
		var x = e.clientX - this.gameinfo.left,
			y = e.clientY - this.gameinfo.top;
		//创建一个大球
		this.createBall(x,y);
		//可以点击次数-1
		this.canClick--;
	},
	//创建一个大球
	createBall : function(x,y){
		
		var ball = new Ball(x,y,60,'Red'),This =this;
		ball.callback = function(){
			This.arrBalls.remove(this);
		}
		
		this.arrBalls.push(ball);
	},
	//创建小球
	createSmallBall : function(){
		
		var sball,randomX,randomY,This= this;
		//循环生成小球
		for(var i =0;i<this.totalSBall;i++){
			//随机出小球出现位置
			randomX = parseInt(Math.random()*7+1,10);
			randomY = parseInt(Math.random()*7+1,10);
			//创建一个小球对象
			sball = new SmallBall(randomX*50,randomY*50,6,'blue');
			sball.speed_x = 2 * (i%2==0?1:-1);
			sball.speed_y = 2 * (i%2==0?-1:1);
			sball.callback = function(){
				This.arrSmallBalls.remove(this);
			}
			this.arrSmallBalls.push(sball);
		}
	},
	//游戏开始
	//btn:开始按钮dom
	start : function(btn){
		
		if(this.btn)this.reset();
		
		this.btn = btn;
		this.btn.disabled = 'disabled';
		
		var This = this;
		
		this.init();
		//开始画画
		this.timeId = setInterval(function(){
			This.process();
		},10);
	},
	//画图处理函数
	process : function(){
		
		var i,l,smallball,ball,changeBig=[];
		//清除画面
		this.gamebg.clearRect(0,0,this.gameinfo.width,this.gameinfo.height);
		//画所有小球
		for(i=0,l=this.arrSmallBalls.length;i<l;i++){
			smallball = this.arrSmallBalls[i];
			if(!smallball)continue;
			smallball.updata(this.gameinfo.width,this.gameinfo.height);
			Canvas.arc(this.gamebg,smallball.x,smallball.y,smallball.radius,smallball.color);
		}
		//画所有的大球
		for(i=0,l=this.arrBalls.length;i<l;i++){
			ball = this.arrBalls[i];
			if(!ball)continue;
			
			//获取被大球其中的小球圆心坐标列表
			changeBig = ball.bitSmallBall(this.arrSmallBalls);
			//循环创建大球
			for(var k=0,kl=changeBig.length;k<kl;k++){
				this.createBall(changeBig[k].x,changeBig[k].y);
			}
			
			ball.updata();
			Canvas.arc(this.gamebg,ball.x,ball.y,ball.radius,ball.color);
		}
		//判断游戏是否结束
		if(!this.arrBalls.length && !this.canClick){
			clearInterval(this.timeId);
			alert('您的分数是：'+(this.totalSBall-this.arrSmallBalls.length));
			this.btn.disabled = '';
		}
	},
	//重置游戏数据
	reset : function(){
		while(this.arrSmallBalls[0]){this.arrSmallBalls.pop();}
		this.arrBalls = [];
		this.timeId = -1;
		this.gamebg = null;
		this.gameinfo = {};
		this.totalSBall = 20;
		this.canClick = 2;
	}
}


